# coding: utf-8

"""
    EPIC API

    REST API for interacting with EPIC (https://epic.zenotech.com) services. <br />                             Please note this API is in BETA and does not yet contain                             all EPIC functionality.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@zenotech.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from epiccore.api_client import ApiClient
from epiccore.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class ConfigApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def config_read(self, app_code, queue_code, **kwargs):  # noqa: E501
        """config_read  # noqa: E501

        Fetch the application configuration for <app_code> running on <queue_code>. Only accessable to authorised users.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.config_read(app_code, queue_code, async_req=True)
        >>> result = thread.get()

        :param app_code: (required)
        :type app_code: str
        :param queue_code: (required)
        :type queue_code: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: SiteConfigurationSerialiser
        """
        kwargs['_return_http_data_only'] = True
        return self.config_read_with_http_info(app_code, queue_code, **kwargs)  # noqa: E501

    def config_read_with_http_info(self, app_code, queue_code, **kwargs):  # noqa: E501
        """config_read  # noqa: E501

        Fetch the application configuration for <app_code> running on <queue_code>. Only accessable to authorised users.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.config_read_with_http_info(app_code, queue_code, async_req=True)
        >>> result = thread.get()

        :param app_code: (required)
        :type app_code: str
        :param queue_code: (required)
        :type queue_code: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(SiteConfigurationSerialiser, status_code(int), headers(HTTPHeaderDict))
        """

        local_var_params = locals()

        all_params = [
            'app_code',
            'queue_code'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method config_read" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'app_code' is set
        if self.api_client.client_side_validation and ('app_code' not in local_var_params or  # noqa: E501
                                                        local_var_params['app_code'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `app_code` when calling `config_read`")  # noqa: E501
        # verify the required parameter 'queue_code' is set
        if self.api_client.client_side_validation and ('queue_code' not in local_var_params or  # noqa: E501
                                                        local_var_params['queue_code'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `queue_code` when calling `config_read`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'app_code' in local_var_params:
            path_params['app_code'] = local_var_params['app_code']  # noqa: E501
        if 'queue_code' in local_var_params:
            path_params['queue_code'] = local_var_params['queue_code']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/config/{app_code}/{queue_code}/', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SiteConfigurationSerialiser',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get('_request_auth'))
